"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IoTDataPlaneService = exports.makeIoTDataPlaneService = void 0;
/**
 * @since 1.0.0
 */
const client_iot_data_plane_1 = require("@aws-sdk/client-iot-data-plane");
const commons_1 = require("@effect-aws/commons");
const effect_1 = require("effect");
const Errors_js_1 = require("./Errors.js");
const Instance = __importStar(require("./IoTDataPlaneClientInstance.js"));
const IoTDataPlaneServiceConfig = __importStar(require("./IoTDataPlaneServiceConfig.js"));
const commands = {
    DeleteThingShadowCommand: client_iot_data_plane_1.DeleteThingShadowCommand,
    GetRetainedMessageCommand: client_iot_data_plane_1.GetRetainedMessageCommand,
    GetThingShadowCommand: client_iot_data_plane_1.GetThingShadowCommand,
    ListNamedShadowsForThingCommand: client_iot_data_plane_1.ListNamedShadowsForThingCommand,
    ListRetainedMessagesCommand: client_iot_data_plane_1.ListRetainedMessagesCommand,
    PublishCommand: client_iot_data_plane_1.PublishCommand,
    UpdateThingShadowCommand: client_iot_data_plane_1.UpdateThingShadowCommand,
};
/**
 * @since 1.0.0
 * @category constructors
 */
exports.makeIoTDataPlaneService = effect_1.Effect.gen(function* () {
    const client = yield* Instance.IoTDataPlaneClientInstance;
    return commons_1.Service.fromClientAndCommands(client, commands, {
        errorTags: Errors_js_1.AllServiceErrors,
        resolveClientConfig: IoTDataPlaneServiceConfig.toIoTDataPlaneClientConfig,
    });
});
/**
 * @since 1.0.0
 * @category models
 */
class IoTDataPlaneService extends effect_1.Effect.Tag("@effect-aws/client-iot-data-plane/IoTDataPlaneService")() {
    static defaultLayer = effect_1.Layer.effect(this, exports.makeIoTDataPlaneService).pipe(effect_1.Layer.provide(Instance.layer));
    static layer = (config) => effect_1.Layer.effect(this, exports.makeIoTDataPlaneService).pipe(effect_1.Layer.provide(Instance.layer), effect_1.Layer.provide(IoTDataPlaneServiceConfig.setIoTDataPlaneServiceConfig(config)));
    static baseLayer = (evaluate) => effect_1.Layer.effect(this, exports.makeIoTDataPlaneService).pipe(effect_1.Layer.provide(effect_1.Layer.effect(Instance.IoTDataPlaneClientInstance, effect_1.Effect.map(IoTDataPlaneServiceConfig.toIoTDataPlaneClientConfig, evaluate))));
}
exports.IoTDataPlaneService = IoTDataPlaneService;
//# sourceMappingURL=IoTDataPlaneService.js.map