"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toIoTDataPlaneClientConfig = exports.setIoTDataPlaneServiceConfig = exports.withIoTDataPlaneServiceConfig = void 0;
const commons_1 = require("@effect-aws/commons");
const effect_1 = require("effect");
const Function_1 = require("effect/Function");
const GlobalValue_1 = require("effect/GlobalValue");
/**
 * @since 1.0.0
 * @category iot-data-plane service config
 */
const currentIoTDataPlaneServiceConfig = (0, GlobalValue_1.globalValue)("@effect-aws/client-iot-data-plane/currentIoTDataPlaneServiceConfig", () => effect_1.FiberRef.unsafeMake({}));
/**
 * @since 1.0.0
 * @category iot-data-plane service config
 */
exports.withIoTDataPlaneServiceConfig = (0, Function_1.dual)(2, (effect, config) => effect_1.Effect.locally(effect, currentIoTDataPlaneServiceConfig, config));
/**
 * @since 1.0.0
 * @category iot-data-plane service config
 */
const setIoTDataPlaneServiceConfig = (config) => effect_1.Layer.locallyScoped(currentIoTDataPlaneServiceConfig, config);
exports.setIoTDataPlaneServiceConfig = setIoTDataPlaneServiceConfig;
/**
 * @since 1.0.0
 * @category adapters
 */
exports.toIoTDataPlaneClientConfig = effect_1.Effect.gen(function* () {
    const { logger: serviceLogger, ...config } = yield* effect_1.FiberRef.get(currentIoTDataPlaneServiceConfig);
    const logger = serviceLogger === true
        ? yield* commons_1.ServiceLogger.toClientLogger(commons_1.ServiceLogger.defaultServiceLogger)
        : (serviceLogger ? yield* commons_1.ServiceLogger.toClientLogger(commons_1.ServiceLogger.make(serviceLogger)) : undefined);
    return { logger, ...config };
});
//# sourceMappingURL=IoTDataPlaneServiceConfig.js.map