import type { ConflictException, InternalFailureException, InvalidRequestException, MethodNotAllowedException, RequestEntityTooLargeException, ResourceNotFoundException, ServiceUnavailableException, ThrottlingException, UnauthorizedException, UnsupportedDocumentEncodingException } from "@aws-sdk/client-iot-data-plane";
import type { TaggedException } from "@effect-aws/commons";
import { SdkError as CommonSdkError } from "@effect-aws/commons";
export declare const AllServiceErrors: readonly ["ConflictException", "InternalFailureException", "InvalidRequestException", "MethodNotAllowedException", "RequestEntityTooLargeException", "ResourceNotFoundException", "ServiceUnavailableException", "ThrottlingException", "UnauthorizedException", "UnsupportedDocumentEncodingException"];
export type ConflictError = TaggedException<ConflictException>;
export type InternalFailureError = TaggedException<InternalFailureException>;
export type InvalidRequestError = TaggedException<InvalidRequestException>;
export type MethodNotAllowedError = TaggedException<MethodNotAllowedException>;
export type RequestEntityTooLargeError = TaggedException<RequestEntityTooLargeException>;
export type ResourceNotFoundError = TaggedException<ResourceNotFoundException>;
export type ServiceUnavailableError = TaggedException<ServiceUnavailableException>;
export type ThrottlingError = TaggedException<ThrottlingException>;
export type UnauthorizedError = TaggedException<UnauthorizedException>;
export type UnsupportedDocumentEncodingError = TaggedException<UnsupportedDocumentEncodingException>;
export type SdkError = CommonSdkError;
export declare const SdkError: import("effect/Data").Case.Constructor<CommonSdkError, "_tag">;
//# sourceMappingURL=Errors.d.ts.map